package io.gitlab.jfronny.inceptum.gtk.window;

import ch.bailu.gtk.gtk.AboutDialog;
import ch.bailu.gtk.gtk.License;
import ch.bailu.gtk.type.Str;
import io.gitlab.jfronny.inceptum.common.BuildMetadata;
import io.gitlab.jfronny.inceptum.gtk.util.I18n;

public class AboutWindow extends AboutDialog {
    public AboutWindow() {
        setProgramName(new Str("Inceptum"));
        setCopyright(new Str("Copyright (C) 2021  JFronny"));
        setVersion(new Str(BuildMetadata.VERSION.toString()));
        setLicenseType(License.MIT_X11);
        setLicense(I18n.str("about.license"));
        setWebsiteLabel(I18n.str("about.contact"));
        setWebsite(new Str("https://jfronny.gitlab.io/contact.html"));
        if (!BuildMetadata.IS_PUBLIC) {
            setComments(I18n.str("about.unsupported-build"));
        }
        int vm = Runtime.version().feature();
        setSystemInformation(I18n.str(BuildMetadata.VM_VERSION == vm ? "about.jvm" : "about.jvm.unsupported", vm));
        //TODO setLogo
    }

    public static void createAndShow() {
        new AboutWindow().show();
    }
}
