package io.gitlab.jfronny.inceptum.launcher.model.curseforge;

import io.gitlab.jfronny.gson.compile.annotations.GSerializable;

import java.util.Date;
import java.util.List;

@GSerializable
public class CurseforgeFile {
    public Integer id;
    public Integer gameId;
    public Integer modId;
    public Boolean isAvailable;
    public String displayName;
    public String fileName;
    /* Possible values:
    1=Release
    2=Beta
    3=Alpha*/
    public Integer releaseType;
    /* Possible values:
    1=Processing
    2=ChangesRequired
    3=UnderReview
    4=Approved
    5=Rejected
    6=MalwareDetected
    7=Deleted
    8=Archived
    9=Testing
    10=Released
    11=ReadyForReview
    12=Deprecated
    13=Baking
    14=AwaitingPublishing
    15=FailedPublishing*/
    public Integer fileStatus;
    public List<Hash> hashes;
    public Date fileDate;
    public Integer fileLength;
    public Long downloadCount;
    public String downloadUrl;
    public List<String> gameVersions;
    public List<GameVersion> sortableGameVersions;
    public List<Dependency> dependencies;
    public Integer alternateFileId;
    public Boolean isServerPack;
    public Long fileFingerprint; // murmur5 hash
    public List<Module> modules;

    @GSerializable
    public static class Hash {
        public String value;
        /* Possible values:
        1=Sha1
        2=Md5*/
        public Integer algo;
    }

    @GSerializable
    public static class GameVersion {
        public String gameVersionName;
        public String gameVersionPadded;
        public String gameVersion;
        public Date gameVersionReleaseDate;
        public Integer gameVersionTypeId;
    }

    @GSerializable
    public static class Dependency {
        public Integer modId;
        /* Possible values:
        1=EmbeddedLibrary
        2=OptionalDependency
        3=RequiredDependency
        4=Tool
        5=Incompatible
        6=Include*/
        public Integer relationType;
    }

    @GSerializable
    public static class Module {
        public String name;
        public Long fingerprint;
    }
}
