package io.gitlab.jfronny.inceptum.launcher.model.curseforge;

import io.gitlab.jfronny.gson.compile.annotations.GSerializable;

import java.util.Date;
import java.util.List;

@GSerializable
public class CurseforgeMod {
    public Integer id;
    public Integer gameId;
    public String name;
    public String slug;
    public Links links;
    public String summary;
    /* Possible values:
    1=New
    2=ChangesRequired
    3=UnderSoftReview
    4=Approved
    5=Rejected
    6=ChangesMade
    7=Inactive
    8=Abandoned
    9=Deleted
    10=UnderReview*/
    public Integer status;
    public Long downloadCount;
    public Boolean isFeatured;
    public Integer primaryCategoryId;
    public List<Category> categories;
    public Integer classId;
    public List<Author> authors;
    public Logo logo;
    public List<Screenshot> screenshots;
    public Integer mainFileId;
    public List<CurseforgeFile> latestFiles;
    public List<LatestFileIndex> latestFilesIndexes;
    public Date dateCreated;
    public Date dateModified;
    public Date dateReleased;
    public Boolean allowModDistribution;
    public Integer gamePopularityRank;
    public Boolean isAvailable;
    public Integer thumbsUpCount;

    @GSerializable
    public static class Links {
        public String websiteUrl;
        public String wikiUrl;
        public String issuesUrl;
        public String sourcesUrl;
    }

    @GSerializable
    public static class Category {
        public Integer id;
        public Integer gameId;
        public String name;
        public String slug;
        public String url;
        public String iconUrl;
        public Date dateModified;
        public Boolean isClass;
        public Integer classId;
        public Integer primaryCategoryId;
    }

    @GSerializable
    public static class Author {
        public Integer id;
        public String name;
        public String url;
    }

    @GSerializable
    public static class Logo {
        public Integer id;
        public Integer modId;
        public String title;
        public String description;
        public String thumbnailUrl;
        public String url;
    }

    @GSerializable
    public static class Screenshot {
        public Integer id;
        public Integer modId;
        public String title;
        public String description;
        public String thumbnailUrl;
        public String url;
    }

    @GSerializable
    public static class LatestFileIndex {
        public String gameVersion;
        public Integer fileId;
        public String filename;
        public Integer releaseType;
        public Integer gameVersionTypeId;
        public Integer modLoader;
    }
}
