package io.gitlab.jfronny.inceptum.launcher.model.fabric;

import io.gitlab.jfronny.gson.compile.annotations.GSerializable;

import java.util.List;

@GSerializable
public class FabricVersionLoaderInfo {
    public FabricLoaderVersion loader;
    public IntermediaryVersion intermediary;

    @GSerializable
    public static class WithMeta extends FabricVersionLoaderInfo {
        public LauncherMeta launcherMeta;

        @GSerializable
        public static class LauncherMeta {
            public int version;
            public Libraries libraries;
            public MainClass mainClass;

            @GSerializable
            public static class Libraries {
                public List<Library> client;
                public List<Library> common;
                public List<Library> server;

                @GSerializable
                public static class Library {
                    public String name;
                    public String url;
                }
            }

            @GSerializable
            public static class MainClass {
                public String client;
                public String server;
            }
        }
    }
}
