package io.gitlab.jfronny.inceptum.launcher.model.inceptum;

import io.gitlab.jfronny.gson.compile.annotations.GSerializable;

import java.util.List;
import java.util.Objects;

@GSerializable
public class InstanceMeta {
    public String version;
    public String java;
    public Long minMem;
    public Long maxMem;
    public Long lastLaunched;
    public Arguments arguments;

    @GSerializable
    public static class Arguments {
        public List<String> jvm;
        public List<String> client;
        public List<String> server;

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            Arguments arguments = (Arguments) o;
            return Objects.equals(jvm, arguments.jvm)
                    && Objects.equals(client, arguments.client)
                    && Objects.equals(server, arguments.server);
        }

        @Override
        public int hashCode() {
            return Objects.hash(jvm, client, server);
        }
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        InstanceMeta that = (InstanceMeta) o;
        return Objects.equals(version, that.version)
                && Objects.equals(java, that.java)
                && Objects.equals(minMem, that.minMem)
                && Objects.equals(maxMem, that.maxMem)
                && Objects.equals(arguments, that.arguments);
    }

    @Override
    public int hashCode() {
        return Objects.hash(version, java, minMem, maxMem, arguments);
    }
}
