package io.gitlab.jfronny.inceptum.launcher.model.modrinth;

import io.gitlab.jfronny.gson.compile.annotations.GSerializable;

import java.util.Date;
import java.util.List;

@GSerializable
public class ModrinthProject {
    public String id;
    public String slug;
    public ModrinthProjectType project_type;
    public String team;
    public String title;
    public String description;
    public String body;
    public String body_url;
    public Date publish;
    public Date updated;
    public String status;
    public License license;
    public ModrinthDependencyType client_side;
    public ModrinthDependencyType server_side;
    public Long downloads;
    public Long follows;
    public List<String> categories;
    public List<String> versions;
    public String icon_url;
    public String issues_url;
    public String source_url;
    public String wiki_url;
    public String discord_url;
    public List<DonationUrl> donation_urls;
    public List<GalleryItem> gallery;

    @GSerializable
    public static class DonationUrl {
        public String id;
        public String platform;
        public String url;
    }

    @GSerializable
    public static class License {
        public String id;
        public String name;
        public String url;
    }

    @GSerializable
    public static class GalleryItem {
        public String url;
        public Boolean featured;
        public String title;
        public String description;
        public Date created;
    }
}
