package io.gitlab.jfronny.inceptum.launcher.model.modrinth;

import io.gitlab.jfronny.gson.compile.annotations.GSerializable;

import java.util.Date;
import java.util.List;

@GSerializable
public class ModrinthVersion {
    public String id;
    public String project_id;
    public String author_id;
    public Boolean featured;
    public String name;
    public String version_number;
    public String changelog;
    public String changelog_url;
    public Date date_published;
    public Long downloads;
    public VersionType version_type;
    public List<File> files;
    public List<Dependency> dependencies;
    public List<String> game_versions;
    public List<String> loaders;

    public enum VersionType {
        alpha, beta, release
    }

    @GSerializable
    public static class File {
        public ModrinthHashes hashes;
        public String url;
        public String filename;
        public Boolean primary;
    }

    @GSerializable
    public static class Dependency {
        public String version_id;
        public String project_id;
        public DependencyType dependency_type;

        public enum DependencyType {
            required,
            optional,
            incompatible
        }
    }
}
