package io.gitlab.jfronny.inceptum.launcher.model.mojang;

import io.gitlab.jfronny.gson.annotations.SerializedName;
import io.gitlab.jfronny.gson.compile.annotations.GSerializable;

import java.util.List;
import java.util.Map;

@GSerializable
public class JvmInfo {
    public Map<String, List<Jvm>> linux;
    @SerializedName("mac-os")
    public Map<String, List<Jvm>> macOs;
    @SerializedName("windows-x64")
    public Map<String, List<Jvm>> windowsX64;

    @GSerializable
    public static class Jvm {
        public Availability availability;
        public MojangFileDownload manifest;
        public Version version;

        @GSerializable
        public static class Availability {
            public int group;
            public int progress;
        }

        @GSerializable
        public static class Version {
            public String name;
            public String released;
        }
    }
}
